#import "Candidate.h"
#import <simtools.h>
#import <math.h>
#import <random.h>
#import "Point.h"
#import "MultiDimSpace.h"
#import "Parameters.h"
#import <gui.h>  //for Pixmap

@implementation Candidate



// These are macros to make it easier to edit notation for
// use of Point objects, especially theta, the direction of movement.
// To get the i't coordinate from a point called "theta", do:
//   GET(theta,i)
// And to set the value to x, do
//
//   SET(theta,i,x)
// Otherwise, you have to do get the coordinate at offset 1 with 
// [theta getCoordinate: i] and set with [theta setCoordinate: i To: x];

#define GET(obj, iii) ([obj getCoordinate: iii])
#define SET(obj, iii, vvv)  ([obj setCoordinate: iii To: vvv])


- createEnd 
{
  return [super createEnd];
}

   
- sayHi 
{
  printf("Hi, I'm a Candidate object\n");
  return self;
}


- initMin: (double) min Max: (double)max Width: (double)width
{
  [super initMin: min Max: max Width: width];
  [self createRealPosition];
  return self;
}


- createRealPosition
{
  myRealPosition = [mdSpace createPoint];
  [myRealPosition setPixmap: polPixmap];
  [myRealPosition copyPositionFrom: myProposal];
  return self;
}


- (Point*)makeProposalAgainst:  (Point *)x 
{
  double dist = [aUniformDist getDoubleWithMin: minStep withMax: maxStep];
  if (myProposal == nil) 
    {
      myProposal = [mdSpace createPoint];
      [myProposal setPixmap: polPixmap];
    }
  


  [self drawProposalFrom: myRealPosition To: myProposal Width: widthOfSearch Distance: dist];
  fprintf(stderr,"p sayhi\n");[myProposal sayHi];
  return myProposal;
}

// if we did better than last time, adopt last proposal as new proposal,
// adopt the direction that got you there as new direction
- (void)receiveResult: (BOOL)win Votes: (int)votes
{
  if (votes > previousVotes)
    {
     
      [goodTheta copyPositionFrom: theta];
    }
  previousVotes = votes;
  if (win == YES)
    {
      [myRealPosition copyPositionFrom: myProposal];
    }
}


#undef SET
#undef GET

@end
