#import "Electioneer.h"
#import "CountHeads.h"
#import "Voter.h"
#import <collections.h>   //for Array

@implementation Electioneer


//we need to create a "distribution" object of counters, one for each candidate
- init: (unsigned)numCandidates
{
  unsigned int j;


  //always need 2 counters, even if only 1 candidate, since status quo is then
  //treated as the opponent.
  unsigned numCountersNeeded =  (numCandidates==1U)?2:numCandidates; 

  distribution = [Array create: [self getZone] setCount: numCountersNeeded ];
    
  for(j=0; j < [distribution getCount]; j++) 
    {
      id counter; 
      counter = [[CountHeads create: [self getZone]] zeroOut];
      [distribution atOffset: j put: counter];
    }

  numWinners= 0;
  numElections = 0; 
  since = 0;

  return distribution;
}


//This is written to allow a different list than voterList to be passed through,
//but I don't do anything with that ability, really.  But if I wanted to randomly
//sample to create sublists, I could put them through here.

- (int)evaluate: (id)proposalList L: (id)myList
{
  unsigned int j;
  int leadingOption = 0;
  int supportForLeader = 0;
  Voter * aVoter;
     

  id <Index> index;
  Point * proposal = nil;

  //reset counters
  for(j=0; j < [distribution getCount]; j++) 
    {
      [[distribution atOffset: j] zeroOut];
    }



  //if there is only one proposal, as for voter response against
  //status quo
  proposal = [proposalList atOffset: 0];
  index = [myList begin:[self getZone]];
  for (aVoter=[index next]; [index getLoc]==Member; aVoter=[index next])
    {
     
      int voterPreference = [aVoter report: proposalList];
      [[distribution atOffset: voterPreference ] addOne];
    }
  [index drop];
  
  printf("RESULTS \n");
  
  for(j=0; j<[distribution getCount]; j++)
    {
      int nSupport =  [[distribution atOffset: j] getCnt];
      if (nSupport > supportForLeader)
	{
	  supportForLeader = nSupport;
	  leadingOption = j;
	}
      
      printf("Number of Voters who choose value %d: %d\n",j,nSupport);
	             
    }
  
  numElections += 1; since += 1;
  
  
  if ( leadingOption != previousWinner)
    {
      [proposal setPolicyColor: 2];
       
     
      numWinners += 1;
      winPct = (100.0 * numWinners) /  (1.0 * numElections) ;
      
      printf("leadingOption != previousWinner! leading=%d, previous=%d, numWinners=%d numElections=%d\n ",leadingOption,previousWinner,numWinners,numElections);     
      //??if there is only 1 proposer, then previousWinner always has
      //to be set to 0, representing the status quo.
      previousWinner = 0;
      
      since = 0;
      return leadingOption;
    }
  else
    {
      printf("The winner was the status quo!");
      winPct= (100.0 * numWinners) /  (1.0 * numElections) ;
      [proposal setPolicyColor: 3];
    }
  
  printf("the number of proposals that beat the sq is %d out of %d elections and the percentage is %f \n",numWinners,numElections,winPct); 
  
  return leadingOption;
}

- (double)getInstability 
{
  return winPct;
  
}


- (double) getStability 
{
  return since;
}   

@end
