#import "Median.h"
#include <stdio.h>   //for printf
#include <stdlib.h>  //for qsort

double
ftabs (double a)
{
  return a < 0 ? -a : a;
}

int
compare_doubles (const double *a, const double *b)
{
  //return (int) (*a - *b);
  return  *a  < *b ? -1 : *a != *b;
}

//Following 2 defines and 2 Functions are from Sedgewick, Algorithms in C

#define exch(A, B) { temp = (A); (A) = (B); (B) = temp; } 
#define less(A,B)  (A<B)

int 
sedgewick_partition(double a[], int l, int r)
{ 
  double temp;
  int i = l-1, j = r; double v = a[r];
  for (;;)
    { 
      while (less(a[++i], v)) ;
      while (less(v, a[--j])) if (j == l) break;
      if (i >= j) break;
      exch(a[i], a[j]);
    }
  exch(a[i], a[r]);
  return i;
}


double
sedgewick_select(double a[], int l, int r, int k)
{ 
  while (r > l)
    { int i = sedgewick_partition(a, l, r);
    if (i >= k) r = i-1;
    if (i <= k) l = i+1;
    } 
  // printf("Sedgewick says median is %f",a[k]);
  return a[k];
}

//This uses qsort, for comparison against the other method
double
findMedian( int k, int n, double testarr[])
{
  long i; 
  
  double arr[n];

  if(n==0)return 999;

  for(i=0;i<n;i++) arr[i]=testarr[i];

  qsort(arr,n,sizeof(double), ( int(*)( const void*,const void*)) compare_doubles);
  // for(i=0;i<n;i++)printf("Looking for %d in sorted array is index: %d %f \n",k-1,i,testarr[i]);
  // printf("qsort says the %d'th array element (index k-1=%d) is: %f  \n",k,k-1, testarr[k-1]);
  return arr[k];
}

