// ObserverSwarm.h				Majority 11

#import "ModelSwarm.h"

#import <simtoolsgui.h>
#import <simtoolsgui/GUISwarm.h>
#import <objectbase.h>
#import <analysis.h>

@interface ObserverSwarm : GUISwarm {
  int displayFrequency;                      // one parameter: update freq
  int NOFSPACES;                             //N of rasters needed
  id displayActions;                         // schedule data structs
  id displaySchedule;

  ModelSwarm * modelSwarm;          	      // the Swarm we're observing

  id <Colormap> colorMap;                     // allocate colours
 
  id <EZGraph>  instabilityGraph;
  id <EZGraph> stabilityGraph;
  id <EZGraph> distanceGraph;

  id <Array> rasters;
}


+ createBegin: (id) aZone;
- createEnd;
- eraseRaster;

- _update_;
- buildObjects;
- getRasters;

//- drawFeature: (int) f PointX: (double) posX Y: (double) posY Color: (int) type;

- drawMedianLines;
- buildActions;
- activateIn: (id) swarmContext;
- checkToStop;

@end

