// ObserverSwarm.m				simpleObserverBug2

#import "ObserverSwarm.h"
#import <gui.h>
#import "MultiDimSpace.h"
#import "Parameters.h"
#import "tkobjc/internal.h"


@implementation ObserverSwarm

+ createBegin: (id)aZone 
{
  ObserverSwarm * obj;
  // id < ProbeMap >  probeMap;

  obj = [super createBegin: aZone];
  
  obj->displayFrequency = 1;
  
  //  probeMap = [EmptyProbeMap createBegin: aZone];
  //   [probeMap setProbedClass: [self class]];
  //   probeMap = [probeMap createEnd];
  //   [probeMap addProbe: [probeLibrary getProbeForVariable: "displayFrequency"
  //                                     inClass: [self class]]];
  
  
  // [probeLibrary setProbeMap: probeMap For: [self class]];

  return obj;
}

- createEnd 
{
  return [super createEnd];
}

- _instabilityGraphDeath_ : caller
{
  [instabilityGraph drop];
  instabilityGraph = nil;
  return self;
}



- _stabilityGraphDeath_ : caller
{
  [stabilityGraph drop];
  stabilityGraph = nil;
  return self;
}



- _distanceGraphDeath_ : caller
{
  [distanceGraph drop];
  distanceGraph = nil;
  return self;
}

- eraseRaster 
{
  // A method that overrides the default
  // black background for raster and paints
  // the raster white instead
  int i;
  for (i=0; i < NOFSPACES; i++)
    {
      [[rasters atOffset: i] fillRectangleX0: 0
			     Y0: 0
			     X1: [[modelSwarm getMDSpace] getMaxDim: 0]
			     Y1:  [[modelSwarm getMDSpace] getMaxDim: 1]
			     Color: 1];
    }
  return self;
}


- buildObjects 
{
  int i;
  id modelZone;
  int dimensionality;
  
  [super buildObjects];

  modelZone = [Zone create: [self getZone]];


  modelSwarm = [ModelSwarm create: modelZone];
  [modelSwarm setObserverSwarm: self];

  
  

  //We don't need these Probe displays because the parameters
  //are all in the probe for the parameters class.
  //CREATE_ARCHIVED_PROBE_DISPLAY (modelSwarm);
  // CREATE_ARCHIVED_PROBE_DISPLAY (self);

  // unlike a lot of Swarm models, here we stop the action
  // before modelSwarm is created, so we can set parameters
  // in the GUI. After those params are set,
  // we get the ones we need from "arguments" and build
  // objects in modelSwarm
  [controlPanel setStateStopped];

  dimensionality = getInt (arguments, "numDimensions");
  NOFSPACES = (int) ( (dimensionality+1) /  2);
 
  [modelSwarm buildObjects: dimensionality];


  // colorMap is needed for the raster colors.
  colorMap = [Colormap create: [self getZone]];
  
  [colorMap setColor: 0 ToName: "black"];
  [colorMap setColor: 1 ToName: "white"];
  [colorMap setColor: 2 ToName: "green"];
  [colorMap setColor: 3 ToName: "red"];
  [colorMap setColor: 4 ToName: "yellow"];
  
 

  rasters = [Array create: self setCount: NOFSPACES];
  
  for (i=0; i < NOFSPACES; i++)
    {
      char rasterName[30];
      id worldRaster;
      int xmax = [[modelSwarm getMDSpace] getMaxDim: i*2];
      int ymax = ( (dimensionality%2 != 0) && (i == NOFSPACES -1) ) ? 
	20:[[modelSwarm getMDSpace] getMaxDim: i*2];
      

      sprintf(rasterName,"PolicySpace%02d-%02d",i*2,i*2+1);
      worldRaster = [ZoomRaster createBegin: [self getZone]];
      [worldRaster setWindowGeometryRecordName: strdup(rasterName)];
      worldRaster = [worldRaster createEnd];
      [worldRaster setColormap: colorMap];

      [worldRaster setZoomFactor: 4];

      [worldRaster setWidth: xmax
		   Height: ymax ];
      [worldRaster setWindowTitle: rasterName];
   
 
      [worldRaster pack]; 
      [rasters atOffset: i put: worldRaster];
    }

      // Also, tell the world raster to send mouse clicks to the bugDisplay
      // this allows the user to right-click on the display to probe the bugs.
  
      //  [worldRaster setButton: ButtonRight Client: voterDisplay Message: M(makeProbeAtX:Y:)];
  
  stabilityGraph = [EZGraph createBegin: [self getZone]];
  SET_WINDOW_GEOMETRY_RECORD_NAME (stabilityGraph);
  [stabilityGraph setTitle: "Amount of policy Stability"];
  [stabilityGraph setAxisLabelsX: "time" Y: "periods since last policy change"];
  stabilityGraph = [stabilityGraph createEnd];

  [stabilityGraph enableDestroyNotification: self
                notificationMethod: @selector (_stabilityGraphDeath_:)];
 

  [stabilityGraph createSequence: "stability"
                         withFeedFrom: [modelSwarm getElectioneer] 
                          andSelector: M(getStability)];

  instabilityGraph = [EZGraph createBegin: [self getZone]];
  SET_WINDOW_GEOMETRY_RECORD_NAME (instabilityGraph);
  [instabilityGraph setTitle: "Amount of policy Instability"];
  [instabilityGraph setAxisLabelsX: "time" Y: "Pct. of Periods with Policy Change"];
  instabilityGraph = [instabilityGraph createEnd];
 
  [instabilityGraph enableDestroyNotification: self
		    notificationMethod: @selector (_instabilityGraphDeath_:)];
  

       
  [instabilityGraph createSequence: "instability"
		    withFeedFrom: [modelSwarm getElectioneer] 
		    andSelector: M(getInstability)];


  distanceGraph = [EZGraph createBegin: [self getZone]];
  SET_WINDOW_GEOMETRY_RECORD_NAME (distanceGraph);
  [distanceGraph setTitle: "Weighted Moving Average Distance from Median"];
  [distanceGraph setAxisLabelsX: "time" Y: "EWMA"];
  distanceGraph = [distanceGraph createEnd];
 
  [distanceGraph enableDestroyNotification: self
                notificationMethod: @selector (_distanceGraphDeath_:)];


       
  [distanceGraph createSequence: "distance"
		 withFeedFrom: modelSwarm 
		 andSelector: M(getDistFromMedian)];




  return self;
}


- getRasters
{
  return rasters;
}


// - drawFeature: (int)f PointX: (double)posX Y: (double)posY Color: (int)type 
// {

//   id drawingRaster = [rasters atOffset: f];
//   [drawingRaster drawPointX: floor(posX+0.5) Y: (posY+0.5) Color: type];

//    return self;
// }


- _update_
{
  int i;
  [self eraseRaster];

  [self drawMedianLines];

  [modelSwarm drawAgents];
  
  [modelSwarm getDistFromMedian];

  for(i=0;i<NOFSPACES;i++)
    {
      [[rasters atOffset: i] drawSelf];
    }
  return self;
}



- drawMedianLines
{
  int i, j;
  Point * theMedian = [modelSwarm getMedian];

  for ( i = 0; i < NOFSPACES; i++ )
    {
      id aRaster = [rasters atOffset: i]; 
      for ( j = 0; j < 2; j++ )
	{
	  int theCoordinate = i*2 + j;
	  double coordinate = [theMedian getCoordinate: theCoordinate];
	  if ( (j % 2) == 0) 
	    {
	      id aPix =  [[[Pixmap createBegin: self] 
			    setFile: "redBox.png"] 
			   createEnd];
	      [aPix setRaster: aRaster];
       
	      [aRaster draw:  aPix  X: 10  Y: 10];
	      [aRaster drawPointX: 10 Y: 10 Color: 4];
	     
	      [aRaster lineX0: (int)coordinate  Y0: 0 X1: (int)coordinate Y1: [[modelSwarm getMDSpace] getMaxDim: i*2]  Width: 1 Color: 3];
	    }
	  else 
	    {
	      [aRaster lineX0: 0  Y0: (int)coordinate X1:[[modelSwarm getMDSpace] getMaxDim: i*2+1]  Y1: (int)coordinate  Width: 1 Color: 3];	   

	    }
	}
    }
  return self;
}     
    




- buildActions 
{
  [super buildActions];

  [modelSwarm buildActions];
  [self eraseRaster];

  displayActions = [ActionGroup create: [self getZone]];
  [displayActions createActionTo: self         message: M(_update_)];
  [displayActions createActionTo: instabilityGraph     message: M(step)];
  [displayActions createActionTo: stabilityGraph       message: M(step)];
  [displayActions createActionTo: distanceGraph       message: M(step)];

 
  [displayActions createActionTo: self message: M(checkToStop)];
  [displayActions createActionTo: actionCache message: M(doTkEvents)];


  displaySchedule = [Schedule createBegin: [self getZone]];
  [displaySchedule setRepeatInterval: displayFrequency]; // note frequency!
  displaySchedule = [displaySchedule createEnd];
  [displaySchedule at: 0 createAction: displayActions];
 
  return self;
}

- activateIn: (id)swarmContext 
{
  [super activateIn: swarmContext];
  [modelSwarm activateIn: self];
  [displaySchedule activateIn: self];

  return [self getSwarmActivity];
}

- checkToStop
{
  if ((int)getCurrentTime() == getInt(arguments,"duration"))
    {
      [actionCache doTkEvents];
      [controlPanel setStateStopped];
    }
  return self;
 
}
@end








