#import "Voter.h"
#import "Point.h"
#import <random.h>
#import "ObserverSwarm.h"

@implementation Voter


-setMDSpace: (MultiDimSpace*)w 
{
  mdSpace = w;
  return self;
}
    

- setObserverSwarm: anObserver
{
  observerSwarm = anObserver;
  return self;
}

-createEnd
{
  [super createEnd];
  return self;
}

-sayHi
{
  int i;
  printf("I'm here, voter number %d, and my ideal is:", idnum);
  for (i=0; i< [ideal getNumDimensions]; i++)
	 printf( "%f, ", [ideal getCoordinate: i]);
  printf("\n");
  return self;
}

- setidnum: (int)num
{
  idnum=num;
  return self;
}      


- setIdealPoint: (Point *)aPoint
{
  ideal = aPoint;
  return self;
}
    
- (Point *)getIdeal
{
  return ideal;
}

- (int)report: list 
{   
  //  printf ("I'm offered %d alternatives\n",[list getCount]);
  //  printf ("ideal\n"); [ideal sayHi];
  //  printf ("proposal \n"); [[list atOffset: 1] sayHi];
  //  printf ("current \n"); [[list atOffset: 0] sayHi];
  //  diagnostic:

  double lowestDisutility = 99999999;
  int i;
  int bestOption = 0;
  int numOptions = [list getCount];
  

  for (i=0; i < numOptions; i++)
    {
      Point * anOption = [list atOffset: i];
      double disutility = [ideal distanceFrom: anOption];
      if (disutility < lowestDisutility)
	{
	  lowestDisutility = disutility;
	  bestOption = i;
	}
      
    }
  //printf("Report ideal lowestDisutility=%f Favorite=%d \n", lowestDisutility, bestOption); 
  return bestOption;
}  



- setVoterColor: (Color)c 
{
  voterColor = c;
  [ideal setPolicyColor: voterColor];
  return self;
}


- drawSelfOn: (id)r
{
  [ideal drawSelfOn: observerSwarm];

  return self;
}




@end   
   
